-- Math routines (tested with Euphoria 2.4)
--
-- (c) Juergen Luethje <http://home.arcor.de/luethje/>
-- mbox 1.00 -- 2003, Nov 09
-- Freeware
-- License see "mbox_eng.txt"

include get.e

type nonnegative_int (object x)
   -- called by digits10()
   if integer(x) then
      return x >= 0
   end if
   return 0
end type

------------------------------------------------------------------------

integer val_err_no
val_err_no = 0

global function val_err ()
   -- called by mail_date()
   return val_err_no
end function

global function val (sequence s)
   -- called by mail_date()
   object ret
   sequence v

   v = value(s)
   if v[1] = GET_SUCCESS then
      ret = v[2]
      if atom(ret) then
         val_err_no = 0
         return ret
      end if
   end if

   val_err_no = 1
   return 0
end function

------------------------------------------------------------------------

global function ceil (object x)
   -- the opposite of floor()
   -- x may be an atom or a sequence
   -- called by serial_to_time()
   return -floor(-x)
end function


global function frac (object x)
   -- return the noninteger part of (all elements of) x (signed)
   -- x may be an atom or a sequence
   -- called by serial_to_time()
   return remainder(x, 1)
end function


constant ln10 = log(10)

global function digits10 (nonnegative_int i)
   -- called by OpenArchive()
   if i != 0 then
      return floor(log(i)/ln10) + 1
   end if
   return 1
end function

